osgAnimation::Animation Class Reference

`#include <Animation>`

Inheritance diagram for osgAnimation::Animation:

## Public Types

enum | PlayMode { ONCE , STAY , LOOP , PPONG }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| META_Object (osgAnimation, Animation) Animation()
| Animation (const osgAnimation::Animation &, const osg::CopyOp &)
void | addChannel (Channel *pChannel)
void | removeChannel (Channel *pChannel)
ChannelList & | getChannels ()
const ChannelList & | getChannels () const
void | setDuration (double duration)
void | computeDuration ()
double | getDuration () const
double | computeDurationFromChannels () const
void | setWeight (float weight)
float | getWeight () const
bool | update (double time, int priority=0)
void | resetTargets ()
void | setPlayMode (PlayMode mode)
PlayMode | getPlayMode () const
void | setStartTime (double time)
double | getStartTime () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

| ~Animation ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

double | _duration
double | _originalDuration
float | _weight
double | _startTime
PlayMode | _playmode
ChannelList | _channels
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Enumeration Documentation

## PlayMode

enum osgAnimation::Animation::PlayMode

Enumerator
ONCE |
STAY |
LOOP |
PPONG |

## Constructor & Destructor Documentation

## Animation()

osgAnimation::Animation::Animation | ( | const osgAnimation::Animation & | ,
|  | const osg::CopyOp & | )

Referenced by META_Object().

## ~Animation()

osgAnimation::Animation::~Animation | ( |  | ) |

inline protected

## Member Function Documentation

## addChannel()

void osgAnimation::Animation::addChannel | ( | Channel * | pChannel | ) |

## computeDuration()

void osgAnimation::Animation::computeDuration | ( |  | ) |

Compute duration from channel and keyframes if the duration is not specified you should call this method before using it

## computeDurationFromChannels()

double osgAnimation::Animation::computeDurationFromChannels | ( |  | ) | const

## getChannels() [1/2]

ChannelList & osgAnimation::Animation::getChannels | ( |  | ) |

Those accessors let you add and remove channels if you modify something that can change the duration you are supposed to call computeDuration or setDuration

Referenced by osgAnimation::AnimationUpdateCallback< T >::link().

## getChannels() [2/2]

const ChannelList & osgAnimation::Animation::getChannels | ( |  | ) | const

## getDuration()

double osgAnimation::Animation::getDuration | ( |  | ) | const

## getPlayMode()

PlayMode osgAnimation::Animation::getPlayMode | ( |  | ) | const

inline

References _playmode.

## getStartTime()

double osgAnimation::Animation::getStartTime | ( |  | ) | const

inline

References _startTime.

## getWeight()

float osgAnimation::Animation::getWeight | ( |  | ) | const

## META_Object()

osgAnimation::Animation::META_Object | ( | osgAnimation | ,
|  | Animation | )

inline

References _duration, _originalDuration, _playmode, _startTime, _weight, Animation(), and LOOP.

## removeChannel()

void osgAnimation::Animation::removeChannel | ( | Channel * | pChannel | ) |

## resetTargets()

void osgAnimation::Animation::resetTargets | ( |  | ) |

## setDuration()

void osgAnimation::Animation::setDuration | ( | double | duration | ) |

Change the duration of animation then evaluate the animation in the range 0-duration it stretch the animation in time. see computeDuration too

## setPlayMode()

void osgAnimation::Animation::setPlayMode | ( | PlayMode | mode | ) |

inline

References _playmode.

## setStartTime()

void osgAnimation::Animation::setStartTime | ( | double | time | ) |

inline

References _startTime.

## setWeight()

void osgAnimation::Animation::setWeight | ( | float | weight | ) |

## update()

bool osgAnimation::Animation::update | ( | double | time,
|  | int | priority = 0 )

## Member Data Documentation

## _channels

ChannelList osgAnimation::Animation::_channels

protected

## _duration

double osgAnimation::Animation::_duration

protected

Referenced by META_Object().

## _originalDuration

double osgAnimation::Animation::_originalDuration

protected

Referenced by META_Object().

## _playmode

PlayMode osgAnimation::Animation::_playmode

protected

Referenced by getPlayMode(), META_Object(), and setPlayMode().

## _startTime

double osgAnimation::Animation::_startTime

protected

Referenced by getStartTime(), META_Object(), and setStartTime().

## _weight

float osgAnimation::Animation::_weight

protected

Referenced by META_Object().

The documentation for this class was generated from the following file:

- Animation